﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace NavsGo
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [MTAThread]
        static void Main()
        {
            Application.Run(new iPhoneMenu());
        }

        //From GPS Diagnostics utility & GPS.NET
        #region Frequenly-Used Images

        /* This utility uses the same graphics across multiple forms.  To minimize the size
         * of the executable, these images are reused.
         */
        public static Bitmap Gps = Properties.Resources.Gps;
        public static Bitmap Warning = Properties.Resources.Warning;
        public static Bitmap Error = Properties.Resources.Error;
        public static Bitmap Ok = Properties.Resources.OK;
        public static Bitmap Question = Properties.Resources.Question;
        public static Bitmap Computer = Properties.Resources.Computer;
        #endregion
    }

    /* The GPS.NET device detection process is multithreaded.  As a result, we must
     * use the Invoke and BeginInvoke methods to ensure that any updates to the form
     * occur on the form's own thread.  This delegate is used by such methods.
     */ 
    public delegate void MethodInvoker();
}